
{	    Copyright (c) 1985, 87 Borland International, Inc.		  }

program DemoOrga;

{$I Float.inc}	{ Dtermine le type Float. }

uses
  Dos, Crt, GDriver, GKernel, GWindow, GShell;

procedure DemOrgan;
var
  X1, Y1, X2, Y2, I, Compte : integer;
  Temp : WrkString;

procedure TraceFlecheHor(X1, Y1, X2, Y2 : integer);
{ Dessine flche horizontale avec sommet en (X2, Y2) }
begin
  DrawLine(X1, Y1, X2, Y2);
  if X2 > X1 then
    begin
      DrawLine(X2 - 4, Y2 - 2, X2, Y2);
      DrawLine(X2 - 4, Y2 + 2, X2, Y2);
    end
  else
    begin
      DrawLine(X2 + 5, Y2 - 2, X2, Y2);
      DrawLine(X2 + 5, Y2 + 2, X2, Y2);
    end;
end; { TraceFlecheHor }

procedure TraceFlecheVer(X1, Y1, X2, Y2 : integer);
{ Dessine flche verticale avec sommet en (X2, Y2) }
begin
  DrawLine(X1, Y1, X2, Y2);
  if Y2 > Y1 then
    begin
      DrawLine(X2 - 2, Y2 - 3, X2, Y2);
      DrawLine(X2 + 2, Y2 - 3, X2, Y2);
    end
  else
    begin
      DrawLine(X2 - 2, Y2 + 3, X2, Y2);
      DrawLine(X2 + 2, Y2 + 3, X2, Y2);
    end;
end; { TraceFlecheVer }

procedure Clignote(Compte, Temps : integer);
{ Fait clignoter la fentre courante }
var
  I : integer;
begin
  for I := 1 to Compte do
  begin
    Delay(Temps);
    InvertWindow;
  end;
end; { Clignote }

begin { DemOrgan }
  DefineWindow(1, 0, 0, 79, 190);     { Dfinit la fentre 'Organigramme' }
  DefineWindow(2, 12, 20, 25, 40);    { Dfinit la fentre 'Dbut' }
  DefineWindow(3, 15, 55, 22, 75);    { Dfinit la fentre 'I=1' }
  DefineWindow(4, 11, 110, 26, 130);  { Dfinit la fentre 'Si I<=5' }
  DefineWindow(5, 47, 90, 56, 110);   { Dfinit la fentre 'I=I+1' }

  ClearScreen;			      { Dessine la fentre cadre }
  SetColorWhite;
  DefineHeader(1, 'UN ORGANIGRAMME');
  SetHeaderOn;
  SelectWindow(1);
  DrawBorder;
  SetHeaderOff;

  SelectWindow(2);		      { Dessine la fentre 'Debut' }
  DrawBorder;
  DrawText(125, 27, 2, 'Debut');
  SetWindowModeOff;
  TraceFlecheVer(151, 40, 151, 55);	{ Dessine la ligne de liaison }
  SetWindowModeOn;

  SelectWindow(3);		      { Dessine la fentre 'I=1' }
  DrawBorder;
  DrawText(136, 63, 2, 'I=1');
  SetWindowModeOff;
  TraceFlecheVer(151, 75, 151, 110);	{ Dessine la ligne de liaison }
  SetWindowModeOn;

  SelectWindow(4);		      { Dessine la fentre 'Si I>=5' }
  DrawBorder;
  DrawText(108, 118, 2, 'Si I<=5');
  DrawStraight(215, 417, 120);	      { Dessine les lignes de liaison }
  SetWindowModeOff;
  TraceFlecheVer(417, 120, 417, 110);
  TraceFlecheVer(151, 130, 151, 155);
  SetWindowModeOn;
  SelectWindow(1);
  DrawText(300, 110, 2, 'OUI');
  DrawText(160, 137, 2, 'NON');

  SelectWindow(5);		      { Dessine la fentre 'I=I+1' }
  DrawBorder;
  DrawText(390, 98, 2, 'I=I+1');
  SetWindowModeOff;
  DrawLine(417, 90, 417, 80);	      { Dessine les lignes de liaison }
  TraceFlecheHor(417, 80, 151, 80);

  SetAspect(1.0);		      { Dessine le cercle 'Fin' }
  DrawCircle(151, 165, 25);
  SelectWindow(1);
  DrawText(137, 163, 2, 'Fin');
  SetWindowModeOn;
  SetHeaderOn;

  CopyScreen;			      { Recopie cet cran   }
				      { sur l'cran virtuel }

  DefineWindow(2, 15, 21, 22, 39);    { Init la fentre mobile }
  SelectWindow(2);
  SetBackground(0);
  DrawBorder;
  InvertWindow;
  Delay(1000);
  InvertWindow;

  Temp := '123456';		      { Initialise l'intervalle des valeurs }
  MoveVer(35, true);		      { dplace fentre sur cadre dpart }
  DrawText(139, 63, 2, 'I=' + Temp[1]);   { L'initialise }
  Clignote(30, 50);
  MoveVer(55, true);		      { La descend pour incrmenter boucle }

  for Compte := 2 to 6 do	       { Incrmente boucle }
  begin
    Delay(500);
    MoveHor(33, true);
    MoveVer(-20, true);
    SetBackground(0);
    DrawBorder;
    DrawText(400, 98, 2, 'I=' + Temp[Compte]);
    Clignote(30, 50);
    MoveVer(-20, true);
    MoveHor(-33, true);
    MoveVer(40, true);
  end;

  InvertWindow;
  Delay(1000);
  MoveVer(46, true);		      { Va  la fentre 'Fin' }
  Clignote(30, 50);

  MoveHor(45, true);		      { Revient en haut }
  MoveVer(-136, true);
  MoveHor(-45, true);
  SetHeaderOn;
end; { DemOrgan }

begin
  InitGraphic;			      { Initialise le systme graphique }

  DemOrgan;			      { Excute dmo }

  repeat until KeyPressed;	      { Attend la frappe d'une touche }

  LeaveGraphic;			      { Quitte le systme graphique }
end. { DemoOrga }

