
{	    Copyright (c) 1985, 87 Borland International, Inc.		  }

program DeplFenetres;

{$I Float.inc}	{ Dtermine le type Float. }

uses
  Dos, Crt, GDriver, GKernel, GWindow, GShell;

const
  Nul = #0; { Caractre Ascii nul }

var
  I : integer;
  Ch : char;

procedure TraceLignes;
var
  I : integer;
begin
  for I := 1 to 20 do
    DrawLine(I * 50, 0, 1000 - I * 50, I * 50);
end; { TraceLignes }


begin { DeplFenetres }

  InitGraphic;		     { Initialise systme graphique }


  DrawBorder;		     { Dessine un bord }
			     { Zone de la premire fentre }
			     { ( Dimensions de la premire fentre par }
			     { dfaut = dimensions de l'cran) }

  DefineWindow(1, Trunc(XMaxGlb / 10), Trunc(YMaxGlb / 10),
		  Trunc(XMaxGlb / 2), Trunc(YMaxGlb / 2));
			     { Dfinit une fentre  1/10e d'cran des  }
			     { cts gauche et haut, et  mi-chemin des }
			     { cts droit et bas.			}

  DefineHeader(1, 'VOICI LA FENETRE FIXE'); { Entte }

  DefineWorld(1, 0, 0, 1000, 1000);   { Donne un systme de coordonnes }
				      { propre				}



  DefineWindow(2, Trunc(XMaxGlb / 2), Trunc(YMaxGlb / 2),
		  Trunc((XMaxGlb * 9) / 10), Trunc((YMaxGlb * 9) / 10));
			     { Dfinit une fentre  mi-chemin des cts }
			     { gauche et haut, et  mi-chemin des cts  }
			     { bas et droit.				 }

  DefineHeader(2, 'VOICI LA FENETRE A DEPLACER'); { Entte }

  DefineWorld(2, 0, 0, 1000, 1000);   { Donne un systme de coordonnes }
				      { propre				}

  SelectWindow(1);	     { Choisit fentre fixe }
  SetHeaderOn;
  SelectWorld(1);	     { Choisit son systme }
  SetBackground(0);	     { Dfinit un fond noir }
  DrawBorder;		     { Encadre la fentre }
  TraceLignes;		       { Dessine des lignes  l'intrieur }
  CopyScreen;		     { Copie sur l'cran virtuel }

  SetBreakOff;		     { Pas de messages d'erreur }
  SetMessageOff;

  SelectWindow(2);	     { Choisit fentre mobile }
  SetHeaderOn;
  SelectWorld(2);	     { Choisit son systme }
  SetBackground(0);	     { Dfinit un fond noir }
  DrawBorder;		     { Encadre la fentre }
  TraceLignes;		       { Dessine des lignes  l'intrieur }

  repeat
    Ch := ReadKey;	     { Lit la frappe }

    if (Ch = Nul) and KeyPressed then { Teste code balayage tendu }
      Ch := ReadKey;
    case Ch of
      'H' : MoveVer(-4, true);	 { Flche haut }
      'K' : MoveHor(-1, true);	 { Flche gauche }
      'M' : MoveHor(1, true);	 { Flche droite }
      'P' : MoveVer(4, true);	 { Flche bas }
    end;
  until Ch = ' ';	     { Le caractre espace sort du programme }

  LeaveGraphic;		     { Quitte systme graphique }
end. { DeplFenetres }
