
{	    Copyright (c) 1985, 87 Borland International, Inc.		  }

program DemoTrouveSyst;

{$I Float.inc}	{ Dtermine le type Float. }

uses
  Dos, Crt, GDriver, GKernel, GWindow, GShell;

procedure DemTrouveSysteme;
var
  X : Float;
  Dx, Dy, I, N, Lignes, Echelle : integer;
  X1, Y1, X2, Y2 : integer;
  B, A : PlotArray;

begin
  DefineWindow(1, 0, 0, XMaxGlb, YMaxGlb); { Fentre = cran complet }
  DefineWindow(2, 0, 0, XMaxGlb, YMaxGlb);
  DefineWorld(1, 0, 0, 1000, 1000);	   { Dfinit systme pour l'cran }

  DefineHeader(2, 'UN REPERE ADAPTE');	   { Fentre de la courbe }
  SelectWindow(2);
  SetHeaderOn;

  N := 10;				   { Remplit la zone du graphe }
  for I := 1 to N do
  begin
    A[I, 1] := I - 1;
    A[I, 2] := random - 0.5;
  end;

  FindWorld(2, A, N, 1, 1.08);		   { Ajuste systme 2 }

  SelectWindow(2);			   { Le choisit et l'encadre }
  DrawBorder;

  Dx := -8;		 { Dessine axes depuis le bord de la fentre }
  Dy := 7;
  X1 := 3;
  Y1 := 5;
  X2 := 25;
  Y2 := 10;
  Lignes := 0;
  Echelle := 0;

  SetLineStyle(0);		 { Dessine une ligne continue courbe }
  DrawAxis(Dx, Dy, X1, Y1, X2, Y2, Lignes, Echelle, false);
  DrawPolygon(A, 1, N, 7, 2, 0);

  SelectWorld(1);			   { Choisit fentre extrieure }
  SelectWindow(1);

  DrawTextW(730, 450, 1, ^['7@2   Donnees ');  { Ecrit lgende }
  DrawTextW(730, 550, 1, '--  Courbe   ');
end; { DemTrouveSysteme }

begin
  InitGraphic;			     { Initialise le systme graphique }

  DemTrouveSysteme;			 { Excute dmo }

  repeat until KeyPressed;	     { Attend la frappe d'une touche }

  LeaveGraphic;			     { Quitte le systme graphique }
end. { DemoTrouveSyst }

