
{	    Copyright (c) 1985, 87 Borland International, Inc.		  }

program UnGraphe;

{$I Float.inc}	{ Dtermine le type Float. }

uses
  Dos, Crt, GDriver, GKernel, GWindow, GShell;

procedure DemGraphe;
var
  N : integer;
  B, A : PlotArray;
  Ch : char;
  X1, X2 : integer;

procedure GenereFonction(var A, B : PlotArray; N : integer);
{ Gnre un graphe sinusodal }
var
  I : integer;
  Delta : Float;
begin
  Delta := 2 * Pi / (N - 1);
  for I := 1 to N do
  begin
    A[I, 1] := (I - 1) * Delta - Pi;
    A[I, 2] := Sin(A[I, 1]);
  end;
end; { GenereFonction }

begin
  ClearScreen;

  N := 30;
  GenereFonction(A, B, N);	       { Gnre le graphe }

  DefineWindow(1, 0, 0, XMaxGlb, YMaxGlb);
  DefineHeader(1, 'COURBE SINUSOIDALE');   { Prpare l'cran }
  DefineWorld(1, -Pi, -1, Pi, 1);
  SelectWorld(1);
  SelectWindow(1);
  SetBackground(0);
  SetHeaderOn;
  DrawBorder;

  DrawPolygon(A, 1, N, 0, 0, 0);	 { Dessine le graphe }
end; { DemGraphe }

begin
  InitGraphic;				 { Initialise le systme graphique }

  DemGraphe;				{ Excute la dmo }

  repeat until KeyPressed;		 { Attend la frappe d'une touche }

  LeaveGraphic;				 { Quitte le systme graphique }
end. { UnGraphe }
