{	    Copyright (c) 1985, 87  Borland International, Inc.		   }

program DemoBezi;

{$I Float.inc}	{ Dtermine le type Float. }

uses
  Dos, Crt, GDriver, GKernel, GWindow, GShell;

procedure EffaceJusqueFin;
{ Procdure d'effacement de la fin de la ligne }
var
  I : integer;
begin
  for I := 1 to 80 do
    Write(' ');
end; { EffaceJusqueFin }

procedure DemandeLit(var S : WrkString);
const
  Cr = #13;
  Bs = #8;
var
  Compte : integer;
  Ch	: char;
begin
  Compte := 0;
  S := '';
  repeat
    Ch := ReadKey;
    case Ch of
      Bs : begin
	     if Compte > 0 then
	     begin
	       Write(Ch);
	       ClrEol;
	       Delete(S, Length(S), 1);
	       Dec(Compte);
	     end;
	   end;
    else
      if Ch <> Cr then
      begin
	Write(Ch);
	S := S + Ch;
	Compte := Compte + 1;
      end;
    end;
  until Ch = Cr;
end; { DemandeLit }

procedure DemBezier;

var
  Resultat, I, PointsDeControleMaxi, PointsIntMaxi : integer;
  XFactice, YFactice : Float;
  A, B : PlotArray;
  Break : boolean;
  SFactice, Temp2, Temp : WrkString;

begin
  PointsDeControleMaxi := 7;		   { Initialise tout }
  PointsIntMaxi := 15;

  A[1, 1] := 1;   A[2, 1] := 1.5; A[3, 1] := 2;   A[4, 1] := 2.5;
  A[5, 1] := 3;   A[6, 1] := 4;   A[7, 1] := 5;   A[1, 2] := 2;
  A[2, 2] := 1.5; A[3, 2] := 1;   A[4, 2] := 2.5; A[5, 2] := 4;
  A[6, 2] := 4.5; A[7, 2] := 5;

  ClearScreen;			       { Prpare cran }
  SetColorWhite;
  DefineWorld(1, 0, 0, 6.33, 7.0);     { Initialise le repre }
  SelectWorld(1);
  DefineWindow(1, 0, 0, XMaxGlb, 17 * YMaxGlb div 20);
  SelectWindow(1);
  SetBackground(0);
  DrawBorder;

  Break := false;		       { Init drapeau sortie }

  repeat
    DrawAxis(7, -7, 0, 0, 0, 0, 0, 0, false);
    SetLinestyle(1);		       { Dessine graphe entre points }
    DrawPolygon(A, 1, PointsDeControleMaxi, 4, 2, 0);
    Bezier(A, PointsDeControleMaxi, B, PointsIntMaxi);	{ Opration bezier }
    SetLinestyle(0);		       { Affichage des points }
    ResetAxis;
    DrawPolygon(B, 1, PointsIntMaxi, 0, 0, 0);

    repeat
      GotoXY(1, 24);		       { Effacement de l'ancien texte }
      EffaceJusqueFin;
      GotoXY(1, 25);
      EffaceJusqueFin;
      GotoXY(1, 23);
      EffaceJusqueFin;
      GotoXY(1, 23);		       { Lit point  modifier }
      Write('Numro du point  modifier (0 pour quitter) :  ');
      GotoXY(51, 23);
      DemandeLit(Temp);
      Val(Temp, I, Resultat);
    until I in [0..PointsDeControleMaxi];

    if I > 0 then
      begin
	repeat
	  GotoXY(1, 24);	       { Lit les nouvelles valeurs de x et y }
	  Write('Ancienne position : [', A[I,1]:4:2, ',', A[I,2]:4:2, ']');
	  GotoXY(40, 24);
	  Write('   Nouvelle position  x:  ');
	  GotoXY(65, 24);
	  DemandeLit(SFactice);
	  while SFactice[1] = ' ' do
	    Delete(SFactice, 1, 1);
	  Temp := SFactice;
	  GotoXY(40, 25);
	  Write('   Nouvelle position  y:  ');
	  GotoXY(65, 25);
	  DemandeLit(SFactice);
	  while SFactice[1] = ' ' do
	    Delete(SFactice, 1, 1);
	  Temp2 := SFactice;
	  Val(Temp, XFactice, Resultat);
	  Val(Temp2, YFactice, Resultat);
	until ((XFactice >= X1WldGlb) and (XFactice <= X2WldGlb)) and
	      ((YFactice >= Y1WldGlb) and (YFactice <= Y2WldGlb));

	SetLinestyle(1);	       { Efface ancienne courbe }
	SetColorBlack;
	DrawAxis(0, 0, 0, 0, 0, 0, 0, 0, false);
	DrawPolygon(A, 1, PointsDeControleMaxi, 4, 2, 0);
	SetLinestyle(0);
	DrawAxis(0, 0, 0, 0, 0, 0, 0, 0, false);
	DrawPolygon(B, 1, PointsIntMaxi, 0, 0, 0);
	A[I, 1] := XFactice;
	A[I, 2] := YFactice;
	SetColorWhite;
      end
    else
      Break := true;		       { Termin }
  until Break;
end; { DemBezier }

begin
  InitGraphic;			       { Initialise le systme graphique }

  DemBezier;			       { Excute la dmo }

  LeaveGraphic;
end. { DemoBezi }

