
{	    Copyright (c) 1985, 87 Borland International, Inc.		  }

program DemoDiagSectoriel;

{$I Float.inc}	{ Dtermine le type Float. }

uses
  Dos, Crt, GDriver, GKernel, GWindow, GShell;

procedure DemUnSectoriel;

var
  Somme, X1, Y1, Rayon, Theta, RayonInt, RayonExt : Float;
  N, Mode, Taille : integer;
  A : PieArray;
  Arriere : byte;
  Ch : char;

begin { DemUnSectoriel }
  ClearScreen;
  SetColorWhite;
  DefineWindow(1, 0, 0, XMaxGlb, YMaxGlb);
  DefineHeader(1, 'UN SIMPLE CAMEMBERT'); { Init une fentre }
  DefineWorld(1, 0, 0, 1000, 1000);
  SelectWorld(1);
  SelectWindow(1);
  SetHeaderOn;
  SetBackground(0);
  DrawBorder;

  N := 5;				 { Nombre de segments }
  A[1].Zone := 25;			 { Initialise la zone sectorielle }
  A[2].Zone := 17.5;
  A[3].Zone := 9.6;
  A[4].Zone := 21;
  A[5].Zone := 35;
  A[1].Text := 'JAN.=';
  A[2].Text := 'FEV.=';
  A[3].Text := 'MAR.=';
  A[4].Text := 'AVR.=';
  A[5].Text := 'MAI=';

  A[1].Zone := -A[1].Zone;    { Dplace le premier segment vers l'extrieur }

  X1 := 500;				 { Init le centre en milieu d'cran }
  Y1 := 500;

  Rayon := 200;				{ Init le dbut du cercle }
  Theta := 60;

  SetAspect(1.0);			 { Init le ratio d'aspect }

  RayonInt := 0.7;			 { Init la fin du rayon }
  RayonExt := 1.25;

  Mode := 2;				 { Init pour dessin des deux rayons }
  Taille := 2;				   { Init pour texte taille 2 }

					 { Dessine le diagramme }
  DrawPolarPie(X1, Y1, Rayon, Theta, RayonInt,
	       RayonExt, A, N, Mode, Taille);
end; { DemUnSectoriel }

begin { DemoDiagSectoriel }
  InitGraphic;				 { Initialise le systme graphique }

  DemUnSectoriel;			 { Excute la dmo }

  repeat until KeyPressed;		 { Attend la frappe d'une touche }

  LeaveGraphic;				 { Quitte le systme graphique }
end. { DemoDiagSectoriel }


