
{	    Copyright (c) 1985, 87 Borland International, Inc.		  }

program Interpolation;

{$I Float.inc}	{ Dtermine le type Float. }

uses
  Dos, Crt, GDriver, GKernel, GWindow, GShell;

procedure DemSpline;
var
  X, Temp : Float;
  Dx, Dy, I, N, M, Lignes, Echelle : integer;
  X1, Y1, X2, Y2 : integer;
  B, A : PlotArray;

begin
  DefineWindow(1, 0, 0, XMaxGlb, YMaxGlb); { Dfinit les deux fentres }
  DefineWindow(2, 0, 0, XMaxGlb, YMaxGlb); { en crans complets.       }
  DefineWorld(1, 0, 0, 1000, 1000);  { Dfinit un systme pour l'cran }

  DefineHeader(2, 'Interpolation par Spline'); { Fentre des courbes	 }
  SetHeaderOn;

  N := 12;				   { Remplit intervalle graphe }
  for I := 1 to N do
  begin
    A[I, 1] := I - 1;
    A[I, 2] := random - 0.5;
  end;

  M := 50;				{ Gnre spline avec 50 points }
  Spline(A, N, A[2, 1], A[N - 1, 1], B, M);
  FindWorld(2, B, M, 1, 1.08);		{ Ajuste systme 2 }

  SelectWindow(2);			{ Le choisit et l'encadre }
  DrawBorder;

  Dx := -8;		    { Dessine axe depuis le bord de la fentre }
  Dy := 7;
  X1 := 3;
  Y1 := 5;
  X2 := 25;
  Y2 := 10;
  Lignes := 0;
  Echelle := 0;

  SetLineStyle(1);	       { Dessine courbe initiale en pointills }
  DrawAxis(Dx, Dy, X1, Y1, X2, Y2, Lignes, Echelle, false);
  DrawPolygon(A, 2, N - 1, 7, 2, 0);{ Ne dessine pas les points de fin }

  SetLineStyle(0);	   { Dessine courbe interpole en ligne solide }
  ResetAxis;
  DrawPolygon(B, 1, -M, 0, 0, 0);{ Spline est fausse sur points de fin }

  SelectWorld(1);			  { Choisit fentre extrieure }
  SelectWindow(1);

  DrawTextW(730, 400, 1, ^['7@2   Donnees');	{ Ecrit lgende }
  DrawTextW(730, 500, 1, '..  Polygone d''origine');
  DrawTextW(730, 600, 1, '__  Valeurs interpolees');
end; { DemSpline }

begin
  InitGraphic;			       { Initialise le systme graphique }

  DemSpline;			       { Excute dmo }

  repeat until KeyPressed;	       { Attend la frappe d'une touche }

  LeaveGraphic;			       { Quitte le systme graphique }
end. { Interpolation }
